include file.e
include graphics.e  --for cursor()

--THIS IS A DEMO OF LOADING AND PLAYING WAVE FILES WITH THE ECSTACY SOUND
--SYSTEM. IT IS NOT A TUTORIAL, MAINLY AN EXAMPLE.

--***INCLUDE THE SOUND SYSTEM!
include Ecstacy.e

ECSTACY_DEBUG = 0   --Set to 1 for debugging information saved to "debug.txt"

clear_screen()
puts(1,"Setting Up Sound Card. Please Wait A Few Seconds...\n\n")

--44100Hz, 9 Sound Channels, Auto-Detect sound card.
init_sound(44100, 9, auto_detect())
if SOUND_INIT = 0 then
    position(24,1)
    puts(1,"Could Not Setup Sound Card!")
else
    position(24,1)
    puts(1,"Sound Card Setup Ok!")
end if
position(1,1)

set_global_volume(200)

sequence snds
snds = repeat(0,8)
for i = 1 to 8 do
    --Load the sounds. Un-comment the second line and comment the first,
    --to load sounds form the Pak file instesd of the original wave files.

    snds[i] = load_wave(sprintf("sound%d.wav",i),0)  --from individual files
    --snds[i] = load_stored_wave("sounds.pak",i)      --from Pak file.
					    ----Run "SaveDemo.ex" first to
					    ----make the Pak file.
end for

integer key
key = -1

sequence keys, lkeys
keys = {"12345","67890","qwert","yuiop","asdfg","hjkl;","zxcvb","nm,./"}
lkeys = {"!@#$%","^&*()","QWERT","YUIOP","ASDFG","HJKL:","ZXCVB","NM<>?"}

puts(1,"Hit some keys to play some sound effects from Lemon Headz!!.\n")
puts(1,"Hold shift to loop the sound.\n\n")
printf(1,"Use +/- to change the main volume [%3d]\n",get_global_volume())
puts(1,"Press Spcae To Play A Random Sound Effect.")

position(10,1)
puts(1,"[")
position(10,80)
puts(1,"](Super-Magno-Techno-Spectro-Meter)\n\n")

for i = 1 to 9 do
    text_color(remainder(i,4)+1)
    position(12+i,1)
    print(1,i-1)
end for

object temp
sequence line
atom maxs
maxs = 0

function abs(atom x)
    if x < 0 then
	return -x
    end if
    return x
end function

cursor(NO_CURSOR)

atom stime
stime = time()
sequence channel_height, chh, waits, ccx
channel_height = repeat(0,9)
chh = channel_height
waits = chh
ccx = chh
while key != 27 do
    key = get_key()
    
    for i = 1 to 8 do
	if find(key,keys[i]) then
	    --Play a sound.
	    play_sound(snds[i],{255,i-1,0,(find(key,keys[i])*4000 + 3025)})
	    channel_height[i] = floor((255 * get_global_volume()) / 255)
	    chh[i] = -1
	    waits[i] = 60 - (find(key,keys[i]) * 10)
	    exit
	elsif find(key,lkeys[i]) then
	    --Play a looped sound.
	    play_sound(snds[i],{255,i-1,1,(find(key,lkeys[i])*4000 + 3025)})
	    chh[i] = -1
	    channel_height[i] = floor((255 * get_global_volume()) / 255)
	    waits[i] = 120 - (find(key,keys[i]) * 20)
	    exit
	end if
    end for
    
    if key = ' ' then   --play random sound
	temp = rand({8,155,40000})
	if snds[temp[1]][1] then
		--(loaded sound,{volume,channel,loop,rate})
	    play_sound(snds[temp[1]],{temp[2]+100,8,0,temp[3]})
	    channel_height[9] = floor(((temp[2]+100) * get_global_volume()) / 255)
	    chh[9] = -1
	    waits[9] = 30
	end if
    end if
    
    -- +/- change volume
    if key = '-' or key = '_' then
	temp = get_global_volume()
	temp -= 4
	if temp < 0 then
	    temp = 0
	end if
	set_global_volume(temp)
	position(4,36)
	printf(1,"%3d",get_global_volume())
    elsif key = '=' or key = '+' then
	temp = get_global_volume()
	temp += 4
	if temp > 255 then
	    temp = 255
	end if
	set_global_volume(temp)
	position(4,36)
	printf(1,"%3d",get_global_volume())
    end if

    --REST OF CODE DRAWS THE *COOL* GRAPHICS
    temp = 0
    for i = 0 to 29 do
	temp += peek(DMA_BUFFER + i)
    end for
    temp = abs(floor(temp/30) - 128)
    if maxs <= temp then
	maxs = temp
    else
	maxs -= .5
	if maxs < 0 then
	    maxs = 0
	end if
    end if
    position(8,1)
    temp = floor(time() - stime)
    printf(1,"Time %d:%.2d",{floor(temp/60),remainder(temp,60)})
    position(10,2)
    line = repeat(32,78)
    temp = floor(maxs *.95 * SOUND_INIT)
    if temp > 78 then
	temp = 78
    end if
    if temp > 0 then
	line[1..temp] = '*'
    end if
    text_color(4)
    puts(1,line)

    for i = 1 to 9 do
	if channel_height[i] != chh[i] then
	    position(12+i,1)
	    text_color(remainder(i,4)+1)
	    if waits[i] > 0 then
		waits[i] -= 1
	    elsif channel_height[i] > 0 then
		chh[i] = channel_height[i]
		channel_height[i] -= 2
		if channel_height[i] < 0 then
		    channel_height[i] = 0
		end if
	    else
		chh[i] = channel_height[i]
	    end if
	    line = repeat(32,80)
	    line[1] = i+47
	    if still_playing(i-1) then
		line[2]='*'
	    end if
	    temp = floor(channel_height[i] *.40)
	    if temp > 77 then
		temp = 77
	    end if
	    if temp > 0 then
		line[3..temp+3] = ''
	    end if
	    if i < 9 and snds[i][3] then
		puts(1,line)
	    else
		if i = 9 then
		    puts(1,line)
		else
		    printf(1,"%d (Sound Not Loaded)",i-1)
		end if
	    end if
	elsif ccx[i] = 1 and still_playing(i-1) = 0 then
	    ccx[i] = 0
	    position(12+i,1)
	    text_color(remainder(i,4)+1)
	    puts(1,{i+47,' '})
	elsif still_playing(i-1) = 1 then
	    ccx[i] = 1
	end if
    end for
    text_color(7)

end while

free_waves(snds)    --Free all the memory taken up by the sound effects.
close_sound()       --Shut down the Ecstacy Sound System.

key = machine_func(5, -1)--Return to normal graphics mode.
